package QBWithDBInfo;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Panel;

import javax.swing.JDialog;

import quadbase.ChartAPI.DBInfo;
import quadbase.chart.designer.QbChartDesigner;
import quadbase.common.util.internal.IInterchange;
import quadbase.querybuilder.designer.QbQueryBuilder;

public class QBWithDBInfo extends Applet implements IInterchange {
	static final long serialVersionUID = 1; 
	public QbQueryBuilder queryMain;
	public QbChartDesigner designer;
	String driver = "org.hsqldb.jdbcDriver";
	String url = "jdbc:hsqldb:help/examples/DataSources/database/woodview";
	String username = "sa";
	String password = "";
	
	// Launch this application in the <InstallDir> directory, or provide an absolute path to the <InstallDir>/images and <InstallDir>/backgroundImages directories
	String[] imagesPath = {"images", "backgroundImages"};

	JDialog frame;

	static Applet applet;
	
	public static void main(java.lang.String[] args) {

		try {
			applet = null;
			QBWithDBInfo qb = new QBWithDBInfo();
			if ((args != null) && (args.length > 0)) qb.doQueryBuilderApplet(null, args[0]);
			else qb.doQueryBuilderApplet(null, null);

		} catch (Exception ex) { ex.printStackTrace(); }

	}

	public void init()  {
		try {
			applet = this;
			doQueryBuilderApplet(this, null);
			setLayout(new BorderLayout());
			Panel panel = new Panel();
			panel.setLayout(new BorderLayout());
			panel.add("Center", new Label("LOADING"));
			add("Center", panel);

		} catch (Exception ex) { ex.printStackTrace(); }
	}

	public void doQueryBuilderApplet(Object parent, String sqlName) throws Exception  {
		QbChartDesigner.setServerAddress("127.0.0.1");
		QbChartDesigner.setServerPortNumber(22071);
		
		queryMain = new QbQueryBuilder(parent, this);
		if (sqlName != null) {

			//	sqlName .qry file name (without extension)
			//	System.out.println("OPEN QUERY - " + sqlName);
			queryMain.openQuery(sqlName, false, null, null, driver, url, username, password);

		} else {

			//	System.out.println("NEW QUERY ");
			queryMain.newQuery("Setup Query", false, null, null, driver, url, username, password);

		}
		frame = queryMain.getBuilder();
		frame.setVisible(true);
		try { queryMain.showTablesWindow();
		} catch (Exception ex) {};

	}

	public void back() {};

	public void cancel() {};

	public void next() {
		queryMain.getBuilder().setVisible(false);
		DBInfo dbInfo = new DBInfo(url, driver, username, password, queryMain.getSQL());
		designer = new QbChartDesigner(applet, dbInfo, queryMain.getInSet(), true, imagesPath);
		designer.setVisible(true);
	}

}